unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, ColorGrd, ExtCtrls, StdCtrls, Buttons, ImgList,
  ComCtrls, ToolWin, Math, Menus;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    New: TSpeedButton;
    Per: TSpeedButton;
    Del: TSpeedButton;
    Put: TSpeedButton;
    Clear: TSpeedButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    OstTree: TSpeedButton;
    Timer1: TTimer;
    Obnov: TSpeedButton;
    SaveButton: TSpeedButton;
    LoadButton: TSpeedButton;
    ToolButton4: TToolButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    HelpButton: TSpeedButton;
    Deykstri: TSpeedButton;
    InsertButton: TSpeedButton;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    N25: TMenuItem;
    Strela: TSpeedButton;
    N26: TMenuItem;
    Floid: TSpeedButton;
    procedure FormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ClearClick(Sender: TObject);
    procedure Form1Paint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure OstTreeClick(Sender: TObject);
    procedure ObnovClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DeykstriClick(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure NewClick(Sender: TObject);
    procedure DelClick(Sender: TObject);
    procedure PerClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure PutClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure N26Click(Sender: TObject);
    procedure StrelaClick(Sender: TObject);
    procedure FloidClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
  private
    { Private declarations }
    procedure MouseDown (Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    procedure MouseMove (Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
    procedure MouseUp (Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    procedure PaintLine(Beg, En: TShape; Dlina1,Dlina2:Integer);
    function Proverka():Byte;
    function ProvSvaz():Boolean;
    procedure Poradok();
  public
    { Public declarations }
    s:String;
  end;
type
TMouseState = (msNonnal, msDragging);
var
  Form1: TForm1;
  shapes:array[1..99] of TShape;     // 
  Mas:array[1..99,1..99] of Integer;    //  -  , i,j -     
  TreeMas,AlgD,AlgF:array[1..99,1..99] of Byte; // ,     
  A,Ukaz,N,Circ:TShape; // A -   , N -      , Ukaz -    
  x1,y1,xn,yn,xk,yk:Integer; // x1,y1 -   , xn,yn -   , xk,yk - 
  k,col,numbeg,numend,q,one,two:Byte;  // k -  , col -    , numbeg,numend -      
  OldPos, NewPos: TPoint;
  FMouseState: TMouseState;
  FName:String;
  F:TextFile;
  mycolor:TColor;
  Izmenen:Boolean;

implementation
uses Unit2,Unit3;

{$R *.dfm}

function TForm1.Proverka():Byte;
var i:Byte;
begin
  for i:=1 to k do
    if (shapes[i]=nil) then
    begin
      Proverka:=i;
      Exit;
    end;
  Proverka:=0;
end;

procedure TForm1.PaintLine(Beg, En:TShape; Dlina1,Dlina2:Integer);
var
  BegPos,EndPos,TextPos,Rab:TPoint;
  w:Real;
  sx,sy,Dlina:Integer;
begin
  if (abs(En.Left-Beg.Left)>0) then
  begin
    if (Beg.Left<En.Left) then
    begin
      BegPos.X:=Round(15/sqrt(1+sqr(En.Top-Beg.Top)/sqr(En.Left-Beg.Left)) + Beg.Left+15);
      EndPos.X:=Round(-15/sqrt(1+sqr(Beg.Top-En.Top)/sqr(Beg.Left-En.Left)) + En.Left+15);
    end
      else
      begin
        BegPos.X:=Round(-15/sqrt(1+sqr(En.Top-Beg.Top)/sqr(En.Left-Beg.Left)) + Beg.Left+15);
        EndPos.X:=Round(15/sqrt(1+sqr(Beg.Top-En.Top)/sqr(Beg.Left-En.Left)) + En.Left+15);
      end;
  end
    else
    begin
      BegPos.X:=Beg.Left+15;
      EndPos.X:=En.Left+15;
    end;
  if (Beg.Top<En.Top) then
  begin
     BegPos.Y:=round(sqrt(225-sqr(BegPos.X-Beg.Left-15)) + Beg.Top+15);
     EndPos.Y:=round(-sqrt(225-sqr(EndPos.X-En.Left-15)) + En.Top+15);
  end
     else
     begin
        BegPos.Y:=round(-sqrt(225-sqr(BegPos.X-Beg.Left-15)) + Beg.Top+15);
        EndPos.Y:=round(sqrt(225-sqr(EndPos.X-En.Left-15)) + En.Top+15);
     end;
  TextPos.X:=Round((BegPos.X+EndPos.X)/2);
  TextPos.Y:=Round((BegPos.Y+EndPos.Y)/2);
  Canvas.MoveTo(BegPos.X,BegPos.Y);
  Canvas.LineTo(EndPos.X,EndPos.Y);
  if (Dlina1<>Dlina2) then
  begin
      if Dlina2>0 then
      begin
         Rab:=BegPos;
         BegPos:=EndPos;
         EndPos:=Rab;
      end;
      Canvas.MoveTo(EndPos.X,EndPos.Y);
      w:=(EndPos.Y-BegPos.Y)/(EndPos.X-BegPos.X);
      if BegPos.X<EndPos.X then
      begin
          sx:=round(EndPos.X+8*Cos(ArcTan(w)+8*pi/9));
          sy:=round(8*Sin(ArcTan(w)+8*pi/9)+EndPos.Y);
      end
      else
         begin
            sx:=round(EndPos.X+8*Cos(ArcTan(w)+pi/9));
            sy:=round(8*Sin(ArcTan(w)+pi/9)+EndPos.Y);
         end;
      Canvas.LineTo(sx,sy);
      Canvas.MoveTo(EndPos.X,EndPos.Y);
      if BegPos.X<EndPos.X then
      begin
          sx:=round(EndPos.X+8*Cos(ArcTan(w)+10*pi/9));
          sy:=round(8*Sin(ArcTan(w)+10*pi/9)+EndPos.Y);
      end
      else
         begin
             sx:=round(EndPos.X+8*Cos(ArcTan(w)-pi/9));
             sy:=round(8*Sin(ArcTan(w)-pi/9)+EndPos.Y);
         end;
      Canvas.LineTo(sx,sy);
  end;
  if Dlina1>0 then Dlina:=Dlina1 else Dlina:=Dlina2;
  Canvas.TextOut(TextPos.X,TextPos.Y,IntToStr(Dlina));
end;

procedure TForm1.FormClick(Sender: TObject);
begin
if (New.Down) then
begin
   Izmenen:=true;
   Ukaz:=TShape.Create(Self);
   Ukaz.Shape:=stCircle;
   Ukaz.Left:=x1-15;
   Ukaz.Top:=y1-15;
   Ukaz.Width:=30;
   Ukaz.Height:=30;
   Ukaz.Brush.Color:=clSkyBlue;
   Ukaz.Pen.Width:=2;
   Ukaz.Parent:=Form1;
   Ukaz.OnMouseDown:=MouseDown;
   Ukaz.OnMouseMove:=MouseMove;
   Ukaz.OnMouseUp:=MouseUp;
   k:=k+1;
   Ukaz.Name:='Shape'+IntToStr(k);
   shapes[k]:=Ukaz;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
        i,j:Byte;
begin
        k:=0;
        col:=0;
        one:=0;
        two:=0;
        FName:='';
        Izmenen:=false;
        for i:=1 to 99 do
          for j:=1 to 99 do
          begin
             Mas[i,j]:=0;
             TreeMas[i,j]:=0;
             AlgD[i,j]:=0;
             AlgF[i,j]:=0;
          end;
         Canvas.Font.Color:=clBlue;
         Canvas.Pen.Width:=2;
         Canvas.Brush.Style:=bsClear;
         StatusBar1.Panels[0].Width:=Form1.Width-60;  
end;

procedure TForm1.MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i,j: Byte;
  xx,yy,xt,yt,sx,sy:Integer;
  w:Real;
begin
  for i:=1 to k do
  if (shapes[i]<>nil) then
   if (Sender as TShape).Name = shapes[i].Name Then
   begin
        A:=shapes[i];
        q:=i;
   end;
 if ((Put.Down) or (Strela.Down)) and (Button=mbLeft) then
 begin
   Izmenen:=true;
   col:=col+1;
   x1:=A.Left+15;
   y1:=A.Top+15;
   if (col=1) then
   begin
     Canvas.Pen.Mode:=pmNotXor;
     xn:=x1;
     yn:=y1;
     xk:=x1;
     yk:=y1;
     numbeg:=q;
     N:=A;
   end;
   if (col=2) then
     with Canvas do
     begin
       MoveTo(xn,yn);
       LineTo(xk,yk);
       numend:=q;
       Pen.Mode:=pmCopy;
       if (N<>A) then
       begin
         if (abs(x1-xn)>0) then
         begin
           if (N.Left<A.Left) then
           begin
             xx:=round(15/sqrt(1+sqr(y1-yn)/sqr(x1-xn))+xn);
             xk:=round(-15/sqrt(1+sqr(yn-y1)/sqr(xn-x1))+x1);
           end
             else
             begin
               xx:=round(-15/sqrt(1+sqr(y1-yn)/sqr(x1-xn))+xn);
               xk:=round(15/sqrt(1+sqr(yn-y1)/sqr(xn-x1))+x1);
             end;
         end
           else
           begin
             xx:=x1;
             xk:=xn;
           end;
         if (N.Top<A.Top) then
         begin
            yy:=round(sqrt(225-sqr(xx-xn)) + yn);
            yk:=round(-sqrt(225-sqr(xk-x1)) + y1);
         end
            else
            begin
              yy:=round(-sqrt(225-sqr(xx-xn)) + yn);
              yk:=round(sqrt(225-sqr(xk-x1)) + y1);
            end;
         MoveTo(xx,yy);
         LineTo(xk,yk);
         Form2.ShowModal;
         xt:=round((xx+xk)/2);
         yt:=round((yy+yk)/2);
         Mas[numbeg,numend]:=StrToInt(s);
         if Strela.Down then
         begin
             Mas[numend,numbeg]:=0;
             MoveTo(xk,yk);
             w:=(yk-yy)/(xk-xx);
             if xx<xk then
             begin
                sx:=round(xk+8*Cos(ArcTan(w)+8*pi/9));
                sy:=round(8*Sin(ArcTan(w)+8*pi/9)+yk);
             end
             else
               begin
                  sx:=round(xk+8*Cos(ArcTan(w)+pi/9));
                  sy:=round(8*Sin(ArcTan(w)+pi/9)+yk);
               end;
             LineTo(sx,sy);
             MoveTo(xk,yk);
             if xx<xk then
             begin
                sx:=round(xk+8*Cos(ArcTan(w)+10*pi/9));
                sy:=round(8*Sin(ArcTan(w)+10*pi/9)+yk);
             end
             else
               begin
                  sx:=round(xk+8*Cos(ArcTan(w)-pi/9));
                  sy:=round(8*Sin(ArcTan(w)-pi/9)+yk);
               end;
             LineTo(sx,sy);
         end
         else
            Mas[numend,numbeg]:=StrToInt(s);
         TextOut(xt,yt,s);
       end;
       col:=0; N:=nil;
     end;
 end;
 if (InsertButton.Down) and (Button=mbLeft) then
 begin
      if (q=one) or (q=two) then
      begin
           if (q=one) then
           begin
                shapes[one].Brush.Color:=clSkyBlue;
                one:=two;
                two:=0;
           end;
           if (q=two) then
           begin
                shapes[two].Brush.Color:=clSkyBlue;
                two:=0;
           end;
      end
        else
        begin
             if (one=0) then
             begin
                  one:=q;
                  A.Brush.Color:=clRed;
             end
             else if (two=0) then
                  begin
                       two:=q;
                       A.Brush.Color:=clRed;
                  end
                    else
                    begin
                         shapes[one].Brush.Color:=clSkyBlue;
                         shapes[two].Brush.Color:=clSkyBlue;
                         one:=q;
                         A.Brush.Color:=clRed;
                         two:=0;
                    end;
      end;
      for i:=1 to k do
         for j:=1 to k do
         begin
               AlgD[i,j]:=0;
               AlgF[i,j]:=0;
         end;
      Invalidate();
 end;
 if (Del.Down) and (Button=mbLeft) then
 begin
   if (one=0) and (two=0) then
   begin
   Izmenen:=true;
   ObnovClick(Sender);
   shapes[q].Free;
   shapes[q]:=nil;
   for i:=1 to k do
   begin
        Mas[i,q]:=0;
        Mas[q,i]:=0;
   end;
   Poradok();
   A:=nil;
   end
   else MessageBox(Handle,' !','',MB_OK+MB_ICONWARNING);
 end;
 if (Per.Down) and (Button=mbLeft) then
 begin
   Izmenen:=true;
   FMouseState:= msDragging;
   OldPos:= Point(X, Y);
   Screen.Cursor:=crDrag;
   Circ:=TShape.Create(Self);
   Circ.Shape:=stCircle;
   Circ.Width:=30;
   Circ.Height:=30;
   Circ.Left:=A.Left;
   Circ.Top:=A.Top;
   Circ.Brush.Color:=A.Brush.Color;
   Circ.Pen.Width:=2;
   Circ.Parent:=Form1;
   Circ.OnMouseMove:=MouseMove;
   Circ.OnMouseUp:=MouseUp;
   mycolor:=A.Brush.Color;
   A.Brush.Color:=clAqua;
 end;
end;

procedure TForm1.MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (FMouseState = msDragging) then
  begin
    NewPos := Point(X - OldPos.X, Y - OldPos.Y);
    Circ.Left:=A.Left + NewPos.X;
    Circ.Top:=A.Top + NewPos.Y;
  end;
end;

procedure TForm1.MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Per.Down) then
  begin
    FMouseState := msNonnal;
    Screen.Cursor := crDefault;
    A.Left:=Circ.Left;
    A.Top:=circ.Top;
    A.Brush.Color:=mycolor;
    Form1.Invalidate;
    Circ.Free;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ((Put.Down) or (Strela.Down)) and (col=1) then
  begin
     with Canvas do
     begin
       MoveTo(xn,yn);
       LineTo(xk,yk);
       MoveTo(xn,yn);
       LineTo(x,y);
       xk:=x;
       yk:=y;
     end;
  end;
  if (New.Down) then
  begin
   x1:=x;
   y1:=y;
  end;
end;

procedure TForm1.ClearClick(Sender: TObject);
var i:Byte;
begin
  Canvas.Brush.Color:=Form1.Color;
  Canvas.Brush.Style:=bsSolid;
  Canvas.FloodFill(Width div 2, Height div 2, Color, fsBorder);
  for i:=1 to k do shapes[i].Free;
  Form1.FormCreate(Sender);
end;

procedure TForm1.Form1Paint(Sender: TObject);
var
        i,j:Byte;
begin
  if (k>0) then
  begin
     for i:=2 to k do
       for j:=1 to i-1 do
         if (Mas[i,j]>0) or (Mas[j,i]>0) then
         begin
            if TreeMas[i,j]=1 then Canvas.Pen.Color:=clLime;
            if (AlgD[i,j]=1) then Canvas.Pen.Color:=clRed;
            if (AlgF[i,j]=1) then Canvas.Pen.Color:=$FF00FF;
            PaintLine(shapes[i],shapes[j],Mas[i,j],Mas[j,i]);
            Canvas.Pen.Color:=clBlack;
         end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i:Byte;
begin
     for i:=1 to k do
        shapes[i].Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     StatusBar1.Panels[1].Text:=TimeToStr(Time);
end;

procedure TForm1.Poradok();
var  p,d,i:Byte;
begin
   p:=0;
   d:=Proverka();
   if (d<>0) then
   begin
      for i:= k downto 1 do
         if shapes[i]<>nil then
         begin
            p:=i;
            break;
         end;
      if (p<d) then
         k:=p
      else
        begin
           shapes[d]:=shapes[p];
           shapes[d].Name:='Shape'+IntToStr(d);
           shapes[p]:=nil;
           for i:=1 to k do
           begin
             Mas[i,d]:=Mas[i,p];
             Mas[i,p]:=0;
             Mas[d,i]:=Mas[p,i];
             Mas[p,i]:=0;
           end;
           k:=p-1;
           Poradok();
        end;
   end;
end;

function TForm1.ProvSvaz():Boolean;
var i,j,z:Byte;
begin
   z:=0;
   for i:=1 to k do
      for j:=1 to k do
         if (Mas[i,j]>0) or (Mas[j,i]>0) then
         begin
            z:=z+1;
            break;
         end;
   if z=k then ProvSvaz:=true else ProvSvaz:=false;
end;

procedure TForm1.OstTreeClick(Sender: TObject);
var
   Soed,NoSoed:Set of Byte;
   i,j,nmin,kmin,kol:Byte;
   min:Integer;
   fl:Boolean;
begin
   min:=0;
   nmin:=0;
   kmin:=0;
   if ProvSvaz() then
   begin
      ObnovClick(Sender);
      NoSoed:=[];
      for i:=1 to k do
        Include(NoSoed,i);
      Soed:=[];
      Include(Soed,1);
      Exclude(NoSoed,1);
      repeat
           fl:=false;
           kol:=0;
           for i:=1 to k do
           begin
                if (i in Soed) then
                begin
                   for j:=1 to k do
                   begin
                     if (j in NoSoed) then
                       if (Mas[i,j]>0) and (not(fl)) then
                        begin
                            nmin:=i;
                            kmin:=j;
                            min:=Mas[i,j];
                            fl:=true;
                        end;
                   end;
                end;
           end;
           if fl then
           begin
             for i:=1 to k do
             begin
                 if (i in Soed) then
                 begin
                   for j:=1 to k do
                   begin
                     if (j in NoSoed) then
                       if (Mas[i,j]>0) and (Mas[i,j]<min) then
                        begin
                            nmin:=i;
                            kmin:=j;
                            min:=Mas[i,j];
                        end;
                   end;
                 end;
             end;
             Include(Soed,kmin);
             Exclude(NoSoed,kmin);
             TreeMas[nmin,kmin]:=1;
             TreeMas[kmin,nmin]:=1;
             nmin:=0; kmin:=0; min:=0;
             for i:=1 to k do
                if (i in NoSoed) then kol:=kol+1;
           end;
      until (kol=0) or (not fl);
      if (not fl) then
      begin
        for i:=1 to k do
          for j:=1 to k do
           TreeMas[i,j]:=0;
        MessageBox(Handle,'      !','',MB_OK+MB_ICONWARNING);
      end;
      Invalidate();
   end
   else MessageBox(Handle,'   !','',MB_OK+MB_ICONWARNING);
end;

procedure TForm1.ObnovClick(Sender: TObject);
var
   i,j:Byte;
begin
   for i:=1 to k do
     for j:=1 to k do
     begin
         TreeMas[i,j]:=0;
         AlgD[i,j]:=0;
         AlgF[i,j]:=0;
     end;
   if (one<>0) then shapes[one].Brush.Color:=clSkyBlue;
   if (two<>0) then shapes[two].Brush.Color:=clSkyBlue;
   one:=0;
   two:=0;
   Invalidate();
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
var s:String; i,j:Byte;
begin
   if k>0 then
   begin
   s:='';
   SaveDialog1.FileName:=FName;
   if (SaveDialog1.Execute) then
   begin
        FName:=SaveDialog1.FileName;
        AssignFile(F,FName);
        Rewrite(F);
        for i:=1 to k do
        begin
            s:=IntToStr(shapes[i].Left)+' '+IntToStr(shapes[i].Top);
            for j:=1 to k do
                  if (Mas[i,j]>0) then
                      s:=s+' '+IntToStr(j)+' '+IntToStr(Mas[i,j]);
            WriteLn(F,s);
            s:='';
        end;
        CloseFile(F);
        Izmenen:=false;
   end;
   end
   else MessageBox(Handle,'   !','',MB_OK+MB_ICONINFORMATION);
end;

procedure TForm1.LoadButtonClick(Sender: TObject);
var List:TStringList;
    i,j,p:Byte;
    s:String;
begin
    List:=TStringList.Create;
    if (OpenDialog1.Execute) then
    begin
       Form1.ClearClick(Sender);
       FName:=OpenDialog1.FileName;
       List.LoadFromFile(FName);
       k:=List.Count;
       for i:=1 to k do
       begin
         shapes[i]:=TShape.Create(Self);
         shapes[i].Shape:=stCircle;
         shapes[i].Width:=30;
         shapes[i].Height:=30;
         shapes[i].Brush.Color:=clSkyBlue;
         shapes[i].Pen.Width:=2;
         shapes[i].Parent:=Form1;
         shapes[i].OnMouseDown:=MouseDown;
         shapes[i].OnMouseMove:=MouseMove;
         shapes[i].OnMouseUp:=MouseUp;
         shapes[i].Name:='Shape'+IntToStr(i);
         s:=List.Strings[i-1];
         p:=Pos(' ',s);
         if p>0 then
         begin
            shapes[i].Left:=StrToInt(Copy(s,1,p-1));
            Delete(s,1,p);
         end;
         p:=Pos(' ',s);
         if p>0 then
         begin
            shapes[i].Top:=StrToInt(Copy(s,1,p-1));
            Delete(s,1,p);
         end
         else
            begin
                shapes[i].Top:=StrToInt(s);
                s:='';
            end;
         while s<>'' do
         begin
            p:=Pos(' ',s);
            j:=StrToInt(Copy(s,1,p-1));
            Delete(s,1,p);
            p:=Pos(' ',s);
            if p>0 then
            begin
                 Mas[i,j]:=StrToInt(Copy(s,1,p-1));
                 Delete(s,1,p);
            end
            else
              begin
                 Mas[i,j]:=StrToInt(s);
                 s:='';
              end;
         end;
       end;
       Invalidate;
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var r:Integer;
begin
   if (k>0) and (Izmenen) then
   begin
      r:=MessageBox(Handle,'   ?','',MB_YESNOCANCEL+MB_ICONQUESTION);
      if (r=ID_YES) then  N4Click(Sender)
      else if (r=ID_CANCEL)then Action:=caNone;
   end;
end;

procedure TForm1.DeykstriClick(Sender: TObject);
type
    metka = record
         u:Integer;
         l:Byte;
         m:Char;
    end;
var
    spisok:array[1..99] of metka;
    i,j,nmin:Byte;
    min:Integer;
begin
    if (ProvSvaz()) then
    begin
     if (k>2) and (one>0) and (two>0)
       then
       begin
            for i:=1 to k do
              for j:=1 to k do
              begin
                 AlgD[i,j]:=0;
                 AlgF[i,j]:=0;
              end;
            for i:=1 to k do
              with spisok[i] do
                begin
                   u:=0;
                   l:=0;
                   m:='v';
                end;
            i:=one;
            spisok[i].u:=0;
            spisok[i].l:=0;
            spisok[i].m:='p';
            repeat
                 nmin:=0;
                 min:=0;
                 for j:=1 to k do
                   if (Mas[i,j]>0) and (spisok[j].m='v') then
                     if ((spisok[j].l>0) and (spisok[i].u+Mas[i,j]<spisok[j].u)) or (spisok[j].l=0) then
                        begin
                           spisok[j].u:=spisok[i].u+Mas[i,j];
                           spisok[j].l:=i;
                           spisok[j].m:='v';
                           min:=spisok[j].u;
                           nmin:=j;
                        end;
                 if (min=0) then
                 begin
                      for j:=1 to k do
                        if (spisok[j].m='v') and (spisok[j].l>0) then
                        begin
                           min:=spisok[j].u;
                           nmin:=j;
                           break;
                        end;
                 end;
                 for j:=1 to k do
                    if (spisok[j].u<=min) and (spisok[j].m='v') and (spisok[j].l>0) then
                      begin
                         min:=spisok[j].u;
                         nmin:=j;
                      end;
                 if (nmin>0) then
                 begin
                      i:=nmin;
                      spisok[i].m:='p';
                 end;
            until (nmin=0);
            i:=two;
            j:=0;
            while i<>one do
            begin
                 j:=spisok[i].l;
                 if j=0 then
                 begin
                   MessageBox(Handle,'    !','',MB_OK+MB_ICONWARNING);
                   exit;
                 end;
                 AlgD[i,j]:=1;
                 AlgD[j,i]:=1;
                 i:=j;
            end;
            Invalidate();
     end
     else MessageBox(Handle,'       !','',MB_OK+MB_ICONWARNING);
   end
   else MessageBox(Handle,'   !','',MB_OK+MB_ICONWARNING);
end;

procedure TForm1.N6Click(Sender: TObject);
begin
     Close();
end;

procedure TForm1.N8Click(Sender: TObject);
begin
     ToolBar1.Visible:=not ToolBar1.Visible;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
     StatusBar1.Visible:=not StatusBar1.Visible;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
     New.Down:=not New.Down;
end;

procedure TForm1.N12Click(Sender: TObject);
begin
     Del.Down:=not Del.Down;
end;

procedure TForm1.N13Click(Sender: TObject);
begin
     Per.Down:=not Per.Down;
end;

procedure TForm1.N14Click(Sender: TObject);
begin
     InsertButton.Down:=not InsertButton.Down;
end;

procedure TForm1.N15Click(Sender: TObject);
begin
     Put.Down:=not Put.Down;
end;

procedure TForm1.NewClick(Sender: TObject);
begin
     N11.Checked:=New.Down;
end;

procedure TForm1.DelClick(Sender: TObject);
begin
     N12.Checked:=Del.Down;
end;

procedure TForm1.PerClick(Sender: TObject);
begin
     N13.Checked:=Put.Down;
end;

procedure TForm1.InsertButtonClick(Sender: TObject);
begin
     N14.Checked:=InsertButton.Down;
end;

procedure TForm1.PutClick(Sender: TObject);
begin
   N15.Checked:=Put.Down;
end;

procedure TForm1.N4Click(Sender: TObject);
var
   s:String;
   i,j:Byte;
begin
    if (FName<>'') and (k>0) then
    begin
       s:='';
       AssignFile(F,FName);
       Rewrite(F);
       for i:=1 to k do
       begin
           s:=IntToStr(shapes[i].Left)+' '+IntToStr(shapes[i].Top);
           for j:=1 to k do
               if (Mas[i,j]>0) then
                      s:=s+' '+IntToStr(j)+' '+IntToStr(Mas[i,j]);
           WriteLn(F,s);
           s:='';
       end;
       CloseFile(F);
       Izmenen:=false;
   end
   else Form1.SaveButtonClick(Sender);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     StatusBar1.Panels[0].Width:=Form1.Width-60;
end;

procedure TForm1.N26Click(Sender: TObject);
begin
     Strela.Down:=not Strela.Down; 
end;

procedure TForm1.StrelaClick(Sender: TObject);
begin
     N26.Checked:=not N26.Checked;
end;

procedure TForm1.FloidClick(Sender: TObject);
var DD:array[1..99,1..99] of Integer;
    SS:array[1..99,1..99] of Byte;
    i,j,ved:Byte;
begin
    if ProvSvaz() then
    begin
       if (k>0) and (one>0) and (two>0) then
       begin
            for i:=1 to k do
              for j:=1 to k do
                if Mas[i,j]>0 then SS[i,j]:=j
                  else SS[i,j]:=0;
            for i:=1 to k do
              for j:=1 to k do
                DD[i,j]:=Mas[i,j];
            for i:=1 to k do
              for j:=1 to k do
                 AlgF[i,j]:=0;
            ved:=1;
            while ved<k+1 do
            begin
                for i:=1 to k do
                  for j:=1 to k do
                    if (i<>j) and (i<>ved) and (j<>ved) and (DD[i,ved]>0) and (DD[ved,j]>0) then
                      if (DD[i,ved]+DD[ved,j]<DD[i,j]) or (DD[i,j]=0) then
                      begin
                          DD[i,j]:=DD[i,ved]+DD[ved,j];
                          SS[i,j]:=ved;
                      end;
                ved:=ved+1;
            end;
            i:=one;
            if (SS[i,two]<>two) and (SS[i,two]<>0) then
             while (SS[i,two]<>two) do
               begin
                    j:=SS[i,two];
                    while SS[i,j]<>j do j:=SS[i,j];
                    AlgF[i,j]:=1;
                    AlgF[j,i]:=1;
                    i:=j;
               end;
            if SS[i,two]=two then
               begin
                  AlgF[i,two]:=1;
                  AlgF[two,i]:=1;
               end;
            if SS[i,two]=0 then
            begin
                MessageBox(Handle,'    !','',MB_OK+MB_ICONWARNING);
                exit;
            end;
            Invalidate();
       end
       else MessageBox(Handle,'       !','',MB_OK+MB_ICONWARNING);
    end
    else MessageBox(Handle,'   !','',MB_OK+MB_ICONWARNING);
end;

procedure TForm1.HelpButtonClick(Sender: TObject);
begin
 Form3.RichEdit1.Lines.LoadFromFile('help\.rtf');
 Form3.Show();
end;

end.
